# --
# Copyright (C) 2021-2022 Centuran Consulting, https://centuran.com/
# --
# This software comes with ABSOLUTELY NO WARRANTY. For details, see
# the enclosed file COPYING for license information (GPL). If you
# did not receive this file, see https://www.gnu.org/licenses/gpl-3.0.txt.
# --

use strict;
use warnings;
use utf8;

use vars (qw($Self));

use Kernel::System::PostMaster;

$Kernel::OM->ObjectParamAdd(
    'Kernel::System::UnitTest::Helper' => {
        RestoreDatabase  => 1,
        UseTmpArticleDir => 1,
    },
);
my $Helper = $Kernel::OM->Get('Kernel::System::UnitTest::Helper');

my $ConfigObject = $Kernel::OM->Get('Kernel::Config');
my $MainObject   = $Kernel::OM->Get('Kernel::System::Main');

$Kernel::OM->ObjectsDiscard( Objects => ['Kernel::System::PostMaster::Filter'] );
my $PMFilterObject = $Kernel::OM->Get('Kernel::System::PostMaster::Filter');

print STDERR "BEFORE FR\n";

# my $Email = $MainObject->FileRead(
#     Location => $ConfigObject->Get('Home') . '/scripts/test/sample/PostMaster/DetectAttachmentDoS.eml',
#     Result   => 'SCALAR',
#     Mode     => 'utf8',
# );

my $LargeBlock = ( ( 'Y' x 78 ) . "\n" ) x 500;

#$$Email =~ s/^X+$/$LargeBlock/mg;

my $CommunicationLogObject = $Kernel::OM->Create(
    'Kernel::System::CommunicationLog',
    ObjectParams => {
        Transport => 'Email',
        Direction => 'Incoming',
    },
);
$CommunicationLogObject->ObjectLogStart( ObjectLogType => 'Message' );

my $Email = $MainObject->FileRead(
    Location => $ConfigObject->Get('Home') . '/scripts/test/sample/PostMaster/DetectAttachmentDoS.eml',
    Result   => 'ARRAY',

    #Mode     => 'utf8',
);

my $PostMasterObject = Kernel::System::PostMaster->new(
    CommunicationLogObject => $CommunicationLogObject,

    #Email                  => [ split(/\n/, $$Email) ],
    Email => $Email,

    #Email => \@EmailLines,
    Trusted => 1,
);

$ConfigObject->Set(
    Key   => 'PostMaster::PreFilterModule',
    Value => {
        '000-DetectAttachment' => {
            'Module' => 'Kernel::System::PostMaster::Filter::DetectAttachment',
        }
    }
);

$PostMasterObject->Run( Queue => '' );

use Data::Dumper;

#open my $f, '>', '/tmp/foo';
#print STDERR Dumper { $PMFilterObject->FilterList() };

$Self->Is( 1, 1, "df" );

1;
